#include <stdio.h>
#include <stdlib.h>
#include <rsbac/types.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80],tmp2[120];
  char * key = (void *) 0;
  int i;
  int val;
  union rsbac_attribute_value_t value;
  enum rsbac_target_t target;
  enum rsbac_attribute_t attr;
  
  if (argc > 4)
    {
      printf("%s: %i targets\n\n", argv[0], argc - 4);
      target = get_target_nr(argv[1]);
      attr = get_attribute_nr(argv[2]);
      val = strtol(argv[3],0,0);
      for (i=1;i < (argc-3);i++)
        {
          printf("Processing %s(%i) %i, '%s', attribute %s(%i), value %i\n", argv[1], target, i, argv[i+3], argv[2], attr, val);
          value.dummy = val;
          res = rsbac_set_attr_n(target, argv[i+3], attr, &value);
          if(res)
            {
              if((errno<RSBAC_EPERM) || (errno > RSBAC_EDECISIONMISMATCH))
                printf("errno: %i\n", errno);
              else
                {
                  get_error_name(tmp1,errno);
                  printf("error: %s\n", tmp1);
                }
            }
        }
    }
  else
    {
      printf("\nUse: %s target-type attribute value file/dirname(s)\n", argv[0]);  
      printf("- target-type = FILE or DIR,\n");
      printf("- attribute (string) and value (integer) = see following list:\n");
      for (i=0;i<16;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
      printf("-- press return --");
      scanf("%c", key);
      for (i=16;i<A_none;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
    }
  return (res);
}

